// AVRPromDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include <direct.h>

#include "AVRProm.h"
#include "AVRPromDlg.h"
#include "Prefs.h"

#include "Global.h"
#include "ftd2xx.h"
#include "ftd2def.h"
#include "protos.h"
#include "port_io.h"
#include "spi_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAVRPromDlg Dialogfeld

CAVRPromDlg::CAVRPromDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAVRPromDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAVRPromDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CAVRPromDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAVRPromDlg)
	DDX_Control(pDX, IDC_DEFAULT_FUSES, m_Default);
	DDX_Control(pDX, IDC_SENDRESET, m_SendReset);
	DDX_Control(pDX, IDC_BURNVERIFY, m_BurnVerify);
	DDX_Control(pDX, IDC_FUSEX8, m_Fusex8);
	DDX_Control(pDX, IDC_FUSEX7, m_Fusex7);
	DDX_Control(pDX, IDC_FUSEX6, m_Fusex6);
	DDX_Control(pDX, IDC_FUSEX5, m_Fusex5);
	DDX_Control(pDX, IDC_FUSEX4, m_Fusex4);
	DDX_Control(pDX, IDC_FUSEX3, m_Fusex3);
	DDX_Control(pDX, IDC_FUSEX2, m_Fusex2);
	DDX_Control(pDX, IDC_FUSEX1, m_Fusex1);
	DDX_Control(pDX, IDC_FUSEHI8, m_Fusehi8);
	DDX_Control(pDX, IDC_FUSEHI7, m_Fusehi7);
	DDX_Control(pDX, IDC_FUSEHI6, m_Fusehi6);
	DDX_Control(pDX, IDC_FUSEHI5, m_Fusehi5);
	DDX_Control(pDX, IDC_FUSEHI4, m_Fusehi4);
	DDX_Control(pDX, IDC_FUSEHI3, m_Fusehi3);
	DDX_Control(pDX, IDC_FUSEHI2, m_Fusehi2);
	DDX_Control(pDX, IDC_FUSEHI1, m_Fusehi1);
	DDX_Control(pDX, IDC_FUSE8, m_Fuse8);
	DDX_Control(pDX, IDC_FUSE7, m_Fuse7);
	DDX_Control(pDX, IDC_FUSE6, m_Fuse6);
	DDX_Control(pDX, IDC_FUSE5, m_Fuse5);
	DDX_Control(pDX, IDC_FUSE4, m_Fuse4);
	DDX_Control(pDX, IDC_FUSE3, m_Fuse3);
	DDX_Control(pDX, IDC_FUSE2, m_Fuse2);
	DDX_Control(pDX, IDC_FUSE1, m_Fuse1);
	DDX_Control(pDX, IDC_LOCK8, m_Lock8);
	DDX_Control(pDX, IDC_LOCK7, m_Lock7);
	DDX_Control(pDX, IDC_LOCK6, m_Lock6);
	DDX_Control(pDX, IDC_LOCK5, m_Lock5);
	DDX_Control(pDX, IDC_LOCK4, m_Lock4);
	DDX_Control(pDX, IDC_LOCK3, m_Lock3);
	DDX_Control(pDX, IDC_EDIT2, m_fname);
	DDX_Control(pDX, IDC_IDCHECK, m_CheckID);
	DDX_Control(pDX, IDC_Manuf, m_Manuf);
	DDX_Control(pDX, IDC_Device, m_Device);
	DDX_Control(pDX, IDC_MESSAGE, m_Message);
	DDX_Control(pDX, IDC_LOCK2, m_Lock2);
	DDX_Control(pDX, IDC_LOCK1, m_Lock1);
	DDX_Control(pDX, IDC_CHECKSUM, m_Checksum);
	DDX_Control(pDX, IDC_CHECKSAVEFF, m_SaveFF);
	DDX_Control(pDX, IDC_ENDAKTION, m_Cancel);
	DDX_Control(pDX, IDC_ERASE, m_Erase);
	DDX_Control(pDX, IDC_Preferences, m_Prefs);
	DDX_Control(pDX, IDC_NewFile, m_NewFile);
	DDX_Control(pDX, IDC_Verify, m_Verify);
	DDX_Control(pDX, IDC_Burn, m_Burn);
	DDX_Control(pDX, IDC_Save, m_Save);
	DDX_Control(pDX, IDC_BlankCheck, m_Blank);
	DDX_Control(pDX, IDC_PROGRESS1, m_Percent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAVRPromDlg, CDialog)
	//{{AFX_MSG_MAP(CAVRPromDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BlankCheck, OnBlankCheck)
	ON_BN_CLICKED(IDC_Save, OnSave)
	ON_BN_CLICKED(IDC_Burn, OnBurn)
	ON_BN_CLICKED(IDC_Verify, OnVerify)
	ON_BN_CLICKED(IDC_NewFile, OnNewFile)
	ON_BN_CLICKED(IDC_Preferences, OnPreferences)
	ON_BN_CLICKED(IDC_ERASE, OnErase)
	ON_BN_CLICKED(IDC_ENDAKTION, OnEndaktion)
	ON_CBN_SELCHANGE(IDC_Manuf, OnSelchangeManuf)
	ON_CBN_SELCHANGE(IDC_Device, OnSelchangeDevice)
	ON_BN_CLICKED(IDC_CHECKSAVEFF, OnChecksaveff)
	ON_BN_CLICKED(IDC_CHECKSUM, OnChecksum)
	ON_BN_CLICKED(IDC_IDCHECK, OnIdcheck)
	ON_BN_CLICKED(IDC_LOCK1, OnLock1)
	ON_BN_CLICKED(IDC_LOCK2, OnLock2)
	ON_WM_CLOSE()
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LOCK3, OnLock3)
	ON_BN_CLICKED(IDC_LOCK4, OnLock4)
	ON_BN_CLICKED(IDC_LOCK5, OnLock5)
	ON_BN_CLICKED(IDC_LOCK6, OnLock6)
	ON_BN_CLICKED(IDC_LOCK7, OnLock7)
	ON_BN_CLICKED(IDC_LOCK8, OnLock8)
	ON_BN_CLICKED(IDC_FUSE1, OnFuse1)
	ON_BN_CLICKED(IDC_FUSE2, OnFuse2)
	ON_BN_CLICKED(IDC_FUSE3, OnFuse3)
	ON_BN_CLICKED(IDC_FUSE4, OnFuse4)
	ON_BN_CLICKED(IDC_FUSE5, OnFuse5)
	ON_BN_CLICKED(IDC_FUSE6, OnFuse6)
	ON_BN_CLICKED(IDC_FUSE7, OnFuse7)
	ON_BN_CLICKED(IDC_FUSE8, OnFuse8)
	ON_BN_CLICKED(IDC_FUSEHI1, OnFusehi1)
	ON_BN_CLICKED(IDC_FUSEHI2, OnFusehi2)
	ON_BN_CLICKED(IDC_FUSEHI3, OnFusehi3)
	ON_BN_CLICKED(IDC_FUSEHI4, OnFusehi4)
	ON_BN_CLICKED(IDC_FUSEHI5, OnFusehi5)
	ON_BN_CLICKED(IDC_FUSEHI6, OnFusehi6)
	ON_BN_CLICKED(IDC_FUSEHI7, OnFusehi7)
	ON_BN_CLICKED(IDC_FUSEHI8, OnFusehi8)
	ON_BN_CLICKED(IDC_BURNVERIFY, OnBurnverify)
	ON_BN_CLICKED(IDC_SENDRESET, OnSendreset)
	ON_BN_CLICKED(IDC_FUSEX1, OnFusex1)
	ON_BN_CLICKED(IDC_FUSEX2, OnFusex2)
	ON_BN_CLICKED(IDC_FUSEX3, OnFusex3)
	ON_BN_CLICKED(IDC_FUSEX4, OnFusex4)
	ON_BN_CLICKED(IDC_FUSEX5, OnFusex5)
	ON_BN_CLICKED(IDC_FUSEX6, OnFusex6)
	ON_BN_CLICKED(IDC_FUSEX7, OnFusex7)
	ON_BN_CLICKED(IDC_FUSEX8, OnFusex8)
	ON_BN_CLICKED(IDC_DEFAULT_FUSES, OnDefaultFuses)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAVRPromDlg Nachrichten-Handler

BOOL CAVRPromDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
//1. Lesen der Initialisierungsdatei
//2. Lesen der Bauteilbibliothek
//3. Initialisierung des Brenners

//Programmtitel setzen
    CString ch;

    ch=mytitle;
    ch+=" ";
    
//ProgrammFenster auf alte Position
    RECT myrect; //Struktur fr Fensterdaten
    GetWindowRect(&myrect); //Fensterdaten holen
	
 _getcwd(ininame,_MAX_PATH); //Arbeitsverzeichnis holen inkl. Laufwerk

 strcat(ininame,"\\"); //BackSlash dranhngen sonst Fehler !

 _splitpath(ininame,drive,dir,name,ext);
 _makepath(ininame,drive,dir,"avrisp","ini"); //Pfad zur INI Datei
 _makepath(csvname,drive,dir,"at90list","csv"); //Name der CSV-Datei

 ReadINI();

    if(use_lpt) ch+="LPT Mode";
    if(use_usb) ch+="USB Mode";

	SetWindowText(ch);

	width=myrect.right-myrect.left; //Breite des Fensters
    height=myrect.bottom-myrect.top; //Hhe des Fensters

    lastx=xkoord; //Alte Werte merken fr OnSize()
    lasty=ykoord;

	SetWindowPos(NULL,xkoord,ykoord,width,height,NULL);

// Bei LPT Windows Version ermitteln und evtl. Giveio.sys laden
    if(use_lpt) WindowsVersion();

// Bei USB ftd2xx.dll laden
    if(use_usb)
     {
      if(!LoadFTDLL())
       {
        UnloadFTDLL();
        OnPreferences();
       }
     }

//Brenner initialisieren

    InitPort();

	//Hersteller und Bauteile in die Comboboxen eintragen
    if(FillManuf()==NO_ERRORS)
	 {
      FillDevices();
	 }

    OnSelchangeDevice(); //Zuletzt benutzten Chip einstellen

   //Checkboxes auf den alten Wert setzen
	CheckDlgButton( IDC_CHECKSAVEFF, no_ff ); //Leerbytes speichern
	CheckDlgButton( IDC_CHECKSUM, testcheck ); //Checksumme prfen
	CheckDlgButton( IDC_IDCHECK, checkid ); //ID prfen
	CheckDlgButton( IDC_BURNVERIFY, burnverify ); //Leerbytes speichern
    SetDlgItemText(IDC_EDIT2,fname);

    m_Cancel.EnableWindow(FALSE); //Knopf nur bei Aktionen verfgbar
    mCancel=FALSE; //Grundzustand fr Cancel-Knopf

    offset=0;

	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

//
void CAVRPromDlg::OnPaint() 
//
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CAVRPromDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//#####################################
void CAVRPromDlg::OnClose() 
//#####################################
{

 //Ach du Scheie der Brenner luft noch !!!
 if(FindWindow(NULL,deviltitle)!=NULL) return;

//Alte Fensterposition merkem
    RECT myrect; //Struktur fr Fensterdaten
    GetWindowRect(&myrect); //Fensterdaten holen
	xkoord=myrect.left;
	ykoord=myrect.top;

//1. Schreiben der Initialisierungsdatei
 SaveINI();

//3. Files schlieen
 if(in!=NULL) { fclose(in); in=NULL; }
 if(out!=NULL) {fclose(out); out=NULL; }

 ISP_DISABLE();

 if(use_usb) UnloadFTDLL();

 CDialog::OnClose();
}


//#####################################
void CAVRPromDlg::OnBlankCheck() 
//#####################################
{
 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

 if(ReadDeviceData()==NO_ERRORS)
 {
  DisableControls();
  MoreCPUTime();
  ISP_ENABLE();

  if(SPISync()==NO_ERRORS)
   { 
    BlankCheck();
   }

  ISP_DISABLE();
  NormalCPUTime();
  EnableControls();
 }

 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}

//#####################################
void CAVRPromDlg::OnSave() 
//#####################################
{
 CString ch;

 CFileDialog dlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT,_T(filtersave)); // Save File Dialog
	
//Irgendeine Standarddateierweiterung angeben !! Sonst werden die
//eingestellten Filter von OFN_OVERWRITEPROMPT nicht bercksichtigt !!
//Damit habe ich scheinbar automatisch Speicher zugewiesen zu lpstDefExt
 dlg.m_ofn.lpstrDefExt="hex"; //Standard Dateierweiterung anhngen

//Auerdem Endung im Dateinamen unterdrcken, sonst geht es auch nicht !
 _splitpath(fname,NULL,NULL,name,ext);
 _makepath(fname,NULL,NULL,name,NULL); //Endung nicht im Dialog anzeigen

 dlg.m_ofn.lpstrFile=fname; //Zuletzt benutzter Dateiname ohne Endung
 dlg.m_ofn.lpstrInitialDir=datapath; //Letztes bearbeitetes Verzeichnis
 dlg.m_ofn.nFilterIndex=hexmode+1; //Filter setzen
 
 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 if (dlg.DoModal() == IDOK) //Dateinamen holen oder eingeben
 {
  hexmode=dlg.m_ofn.nFilterIndex-1; //neuen Filter

  if((maxadr>(unsigned long)0x10000)||(maxeepadr>(unsigned long)0x10000)) //16Bit Formate fr Bausteine>64kB verbieten
   {
    if((hexmode==INTEL8)||(hexmode==MOT_S1))
	 {
      Msg("Programmspeicher oder EEPROM haben mehr als 64kB !\n"
	      "Das ausgewhlte Datenformat untersttzt mur 64kB Daten.\n"
		  "Zum auslesen des Bausteines sind folgende Datei-Formate geeignet:\n\n"
		  "Binr\n"
          "Atmel ROM\n"
		  "Intel MCS86\n"
		  "Intel32\n"
		  "Motorola S2\n"
		  "Motorola S3\n\n\n"
		  "*** Vorgang abgebrochen ! ***"
	     );
      return;
	 }
   }

  devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

  strcpy(filename,dlg.GetPathName()); //Pfad
  strcpy(fname,dlg.GetFileName());    //Dateiname

  _splitpath(filename,drive,dir,NULL,NULL);
  _splitpath(fname,NULL,NULL,name,ext);

//Hier eine bse Mischung aus CString und char *
  ch=ext;
  ch.MakeLower(); //Kleinbuchstaben erzeugen

  //Mal sehen ob Endung vorhanden ist
  //Wenn nicht eine dranhngen, je nach Dateiart
  if((hexmode==BIN)&&(ch!="bin")) strcpy(ext,"bin");
  if((hexmode==ATMEL_AVR)&&(ch!="rom")) strcpy(ext,"rom");
  if((hexmode>ATMEL_AVR)&&(ch!="hex")) strcpy(ext,"hex");

//Hierher verlegt um bei Alle Dateien *.* keine Endung zu erzeugen
//oder sogar die alte zu behalten
  if(hexmode==UNKNOWN_HEX) hexmode=BIN; //ist aber auch BIN

//Dateinamen zusammenbauen
  _makepath(filename,drive,dir,name,ext);  //Name fr Programmdaten mit Pfad
  _makepath(eepname,drive,dir,name,"eep"); //Name fr EEPROM-Daten mit Pfad
  _makepath(datapath,drive,dir,NULL,NULL); //Letzten Pfad merken
  _makepath(fname,NULL,NULL,name,ext);     //Name fr Anzeige im Textfeld
										   //und fr sptere Save-Dialoge

  SetDlgItemText(IDC_EDIT2,fname);

  if(ReadDeviceData()==NO_ERRORS) //Bausteindaten lesen
  {
   DisableControls();

//     time_t start,stop;
//     double protime;

//     time(&start);

   MoreCPUTime();
   ISP_ENABLE();

   //Datei ffnen und Baustein auslesen
   if(SPISync()==NO_ERRORS)
    { 
     SaveAVR();
    }

   ISP_DISABLE();
   NormalCPUTime();

//     time(&stop);
//     protime=difftime(stop,start);
//     sprintf(zeile,"Bentigte Zeit %d s",(int)protime);
//     Msg(zeile);

   EnableControls();
  }

 } //if dlg.DoModal

 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}

//#####################################
void CAVRPromDlg::OnBurn() 
//#####################################
{
 int result;
 CString ch;

 result=NO_ERRORS; //Stimmt bis hier

 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

 ch=fname;
 if(ch=="") //Keine Datei angegeben
 {
  result=OnNewFile(); //Dann Datei auswhlen
 }

  _splitpath(filename,drive,dir,NULL,NULL);
  _splitpath(fname,NULL,NULL,name,ext);
  _makepath(filename,drive,dir,name,ext);  //Name fr Programmdaten
  _makepath(eepname,drive,dir,name,"eep"); //Name fr EEPROM-Daten
  _makepath(datapath,drive,dir,NULL,NULL); //Letzten Pfad merken

 if(result==NO_ERRORS) //Datei gewhlt ?
  {
   if(ReadDeviceData()==NO_ERRORS) //Bausteindaten lesen
    {
     DisableControls();

//     time_t start,stop;
//     double protime;

//     time(&start);

     MoreCPUTime();
     ISP_ENABLE();

     if(SPISync()==NO_ERRORS)
      { 

       //Brennroutine aufrufen
       result=Program(filename,MESSAGE_YES,16); //Programmspeicher

       if(maxeepadr>0&&result==NO_ERRORS) //Wenn Daten EEPROM vorhanden
        {
         result=Program(eepname,MESSAGE_NO,8); //Daten Speicher
        }//if(maxeepadr>0)

       if(result==NO_ERRORS) result=ProgramFuseBits(); //Immer !! ChipErase lscht die nicht !
       if(result==NO_ERRORS) result=ProgramLockBits(); //Immmer !! um zurckzusetzen    

      }

	 ISP_DISABLE();
     NormalCPUTime();

//     time(&stop);
//     protime=difftime(stop,start);
//     sprintf(zeile,"Bentigte Zeit %d s",(int)protime);
//     Msg(zeile);

     EnableControls();

    }  // if ReadDeviceData()

  } // if(result==NO_ERRORS) //Datei gewhlt ?
  	
 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}

//#####################################
void CAVRPromDlg::OnVerify() 
//#####################################
{
 int result;
 CString ch;

 result=NO_ERRORS; //Stimmt bis hier

 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

 ch=fname;
 if(ch=="") //Keine Datei angegeben
 {
  result=OnNewFile(); //Dann Datei auswhlen
 }

 if(result==NO_ERRORS) //Datei gewhlt ?
  {
   if(ReadDeviceData()==NO_ERRORS) //Bausteindaten lesen
    {
     DisableControls();
     MoreCPUTime();
     ISP_ENABLE();

     if(SPISync()==NO_ERRORS)
      { 

       result=Verify(filename,MESSAGE_YES,16); //Verify Programmspeicher
       if(maxeepadr>0 && result==NO_ERRORS) //Daten EEPROM auch vergleichen
        {
         result=Verify(eepname,MESSAGE_NO,8); //Verify Daten EEPROM ohne Meldung !!
        }

       if(result==NO_ERRORS) Msg("Keine Fehler beim Prfen !");

      }

     ISP_DISABLE();
     NormalCPUTime();
     EnableControls();
    }//if ReadDeviceData()
 
  }//if result Datei gewhlt

 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}

//#####################################
void CAVRPromDlg::OnErase() 
//#####################################
{
 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

 if(ReadDeviceData()==NO_ERRORS) //Bausteindaten lesen
 {
  DisableControls();
  MoreCPUTime();
  ISP_ENABLE();

  if(SPISync()==NO_ERRORS)
   { 
    //Lschroutine aufrufen
    EraseAVR(); //Erase mit Meldung aufrufen
   }

  ISP_DISABLE();
  NormalCPUTime();
  EnableControls();
 }

 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}

//#####################################
int CAVRPromDlg::OnNewFile() 
//#####################################
{
 CFileDialog dlg(TRUE,		// Open File Dialog
		NULL,		// Default extension
		NULL,		// No default filename
		OFN_FILEMUSTEXIST,		// OPENFILENAME flags
		_T(filter)
		);	// Filter strings
	
 dlg.m_ofn.lpstrInitialDir=datapath; //Letztes bearbeitetes Verzeichnis
 dlg.m_ofn.nFilterIndex=lastfilter; //zuletzt benutzten Filter einstellen

 if (dlg.DoModal() == IDOK)
 {
  lastfilter=dlg.m_ofn.nFilterIndex; //zuletzt benutzten Filter merken
  strcpy(filename,dlg.GetPathName());
  strcpy(fname,dlg.GetFileName());

  _splitpath(filename,drive,dir,NULL,NULL);
  _splitpath(fname,NULL,NULL,name,ext);
  _makepath(filename,drive,dir,name,ext);  //Name fr Programmdaten
  _makepath(eepname,drive,dir,name,"eep"); //Name fr EEPROM-Daten
  _makepath(datapath,drive,dir,NULL,NULL); //Letzten Pfad merken

  SetDlgItemText(IDC_EDIT2,fname);
  return NO_ERRORS;
 }
 return NO_INPUT;
}

//#####################################
void CAVRPromDlg::OnPreferences() 
//#####################################
{
 CPrefs Preferences; //Dialog erstellen

 sprintf(zeile,"0x%X",DATEN); //Alte Werte eintragen
 Preferences.m_PortAdr=zeile;
 Preferences.m_HexLen=hexlen;
 if(beap==0) Preferences.m_Beap=FALSE;
 else Preferences.m_Beap=TRUE;
 Preferences.m_USBSerial=usbserial;
 sprintf(zeile,"%u",usbbaudrate); //Alte Werte eintragen
 Preferences.m_USBBaud=zeile;
 Preferences.m_Use_LPT=use_lpt;
 Preferences.m_Use_USB=use_usb;
 sprintf(zeile,"%ld",slowdown); //Alte Werte eintragen
 Preferences.m_Bremse=zeile;

 if(Preferences.DoModal()==IDOK)
 {
  DATEN=(int)strtol(Preferences.m_PortAdr,NULL,0);
  LESEN=DATEN+1;  // Leseportadresse
  STEUER=DATEN+2; // Steuerportadresse

  slowdown=strtol(Preferences.m_Bremse,NULL,0);
  hexlen=Preferences.m_HexLen&0xFE; //Wert sollte gerade sein
  if(Preferences.m_Beap==FALSE) beap=0;
  else beap=1;
  strncpy(usbserial,Preferences.m_USBSerial,8);
  usbbaudrate=(int)strtol(Preferences.m_USBBaud,NULL,0);

  use_lpt=Preferences.m_Use_LPT;
  use_usb=Preferences.m_Use_USB;

  //Hier eventuell giveio.sys nachladen oder
  //FTDLL Unload bzw FTDLL Load
  //je nach use_lpt, use_usb Status

  if(use_lpt)
   {
    if(ftdll) { UnloadFTDLL(); } //USB Treiber beenden
    
    WindowsVersion(); //fr NT, XP giveio.sys laden
    InitPort();

   }

  if(use_usb)
   {
    if(!ftdll)
     {
      if(!LoadFTDLL()) UnloadFTDLL(); //USB Treiber laden
     }
    InitPort();

   }
  
 }

 CString ch;
 ch=mytitle;

 if(use_lpt) ch+=" LPT Mode";
 if(use_usb) ch+=" USB Mode";

 SetWindowText(ch);

}

void CAVRPromDlg::OnEndaktion() 
 { mCancel=TRUE; } //Signal Abbrechen setzen

void CAVRPromDlg::OnSelchangeManuf() 
{
	manufindex=m_Manuf.GetCurSel(); //Neuer Herstellerindex
    FillDevices(); //Dessen Bausteine lesen
OnSelchangeDevice();
}

void CAVRPromDlg::OnSelchangeDevice() 
{
  SaveINI(); //Alte Einstellungen zum Chip merken !

  deviceindex=m_Device.GetCurSel(); //Neuer Baustein
 
  //Neuen Deviceindex in INI-Datei um bei ReadINI() den richtigen Index zu haben
  _itoa(deviceindex,zeile,10);
  WritePrivateProfileString(MYSECTION,"DeviceIndex",zeile,ininame);

  ReadINI();       //Letzte Einstellungen des Chips holen

  //Checkboxes neu setzen
  CheckDlgButton( IDC_CHECKSAVEFF, no_ff );  //Leerbytes speichern
  CheckDlgButton( IDC_CHECKSUM, testcheck ); //Checksumme prfen
  CheckDlgButton( IDC_IDCHECK, checkid );    //ID prfen
  CheckDlgButton( IDC_BURNVERIFY, burnverify );    //ID prfen
  SetDlgItemText(IDC_EDIT2,fname);           //Letzte Brenndatei
  
  EnableFuses(0);  //Fuses einstellen
}

void CAVRPromDlg::OnChecksaveff() 
 { no_ff=IsDlgButtonChecked(IDC_CHECKSAVEFF); }

void CAVRPromDlg::OnChecksum() 
 { testcheck=IsDlgButtonChecked(IDC_CHECKSUM); }

void CAVRPromDlg::OnIdcheck() 
 { checkid=IsDlgButtonChecked(IDC_IDCHECK); }

void CAVRPromDlg::Msg(char *text)
{
 if(beap) MessageBeep(MB_OK);
 MessageBox(text,meld,MB_ICONINFORMATION|MB_APPLMODAL);
}

int CAVRPromDlg::MsgRetryCancel(char *text)
{
 if(beap) MessageBeep(MB_OK);
 return MessageBox(text,meld,MB_RETRYCANCEL|MB_ICONINFORMATION|MB_APPLMODAL);
}

int CAVRPromDlg::MsgOkCancel(char *text)
{
 if(beap) MessageBeep(MB_OK);
 return MessageBox(text,meld,MB_OKCANCEL|MB_ICONINFORMATION|MB_APPLMODAL);
}

void CAVRPromDlg::UpdateProgress()
{
 progcount++;

 //Progressanzeige updaten
 if(progcount==steps) //-1 weil ???
  {
   PumpMessages(); //Nachrichten von Hand abarbeiten
   stepcount++;
   m_Percent.SetPos(stepcount);
   progcount=0;
  }

}

void CAVRPromDlg::ResetProgress(unsigned long val)
{
 if(val<=RANGE) //Nur sehr wenige Bytes ?
  {
   steps=1;
   m_Percent.SetRange(0,val); //Bereich des Progressindikators festlegen
  }
 else //Nein viele Bytes
  {
   m_Percent.SetRange(0,RANGE); //Bereich des Progressindikators festlegen
   steps=val/RANGE;		  //RANGE Schritte, sonst zu langsam
  }

 progcount=0; //Stepsindikator fr Progresszeile
 stepcount=0; //Zhler fr die Progresszeile
}

//Erzwingt das abarbeiten von aufgelaufenen Fensternachrichten
void CAVRPromDlg::PumpMessages()
{
    // Muss Create() aufrufen, bevor das Dialogfeld verwendet wird
    ASSERT(m_hWnd!=NULL);

    MSG msg;
    // Verarbeiten von Dialogfeld-Nachrichten
    while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
     {
	  if(!IsDialogMessage(&msg))
	   {
        TranslateMessage(&msg);
        DispatchMessage(&msg);  
	   }

	  }//while
}

//Alle Dialogelemente auer "Abbrechen" deaktivieren
void CAVRPromDlg::DisableControls()
{
//Buttons
 m_Burn.EnableWindow(false);
 m_Verify.EnableWindow(false);
 m_Blank.EnableWindow(false);
 m_Save.EnableWindow(false);
 m_NewFile.EnableWindow(false);
 m_Prefs.EnableWindow(false);
 m_Erase.EnableWindow(false);
 m_SendReset.EnableWindow(false);
 m_Default.EnableWindow(false);
//Combos
 m_Manuf.EnableWindow(false);
 m_Device.EnableWindow(false);
//CheckBoxes
 m_BurnVerify.EnableWindow(false);
 m_SaveFF.EnableWindow(false);
 m_Checksum.EnableWindow(false);
 m_CheckID.EnableWindow(false);
//Das Textfenster mit Dateinamen
 m_fname.EnableWindow(false);
//CheckBoxes
 m_Lock1.EnableWindow(false); m_Lock2.EnableWindow(false); m_Lock3.EnableWindow(false); m_Lock4.EnableWindow(false);
 m_Lock5.EnableWindow(false); m_Lock6.EnableWindow(false); m_Lock7.EnableWindow(false); m_Lock8.EnableWindow(false);
 m_Fuse1.EnableWindow(false); m_Fuse2.EnableWindow(false); m_Fuse3.EnableWindow(false); m_Fuse4.EnableWindow(false);
 m_Fuse5.EnableWindow(false); m_Fuse6.EnableWindow(false); m_Fuse7.EnableWindow(false); m_Fuse8.EnableWindow(false);
 m_Fusehi1.EnableWindow(false); m_Fusehi2.EnableWindow(false); m_Fusehi3.EnableWindow(false); m_Fusehi4.EnableWindow(false);
 m_Fusehi5.EnableWindow(false); m_Fusehi6.EnableWindow(false); m_Fusehi7.EnableWindow(false); m_Fusehi8.EnableWindow(false);
 m_Fusex1.EnableWindow(false); m_Fusex2.EnableWindow(false); m_Fusex3.EnableWindow(false); m_Fusex4.EnableWindow(false);
 m_Fusex5.EnableWindow(false); m_Fusex6.EnableWindow(false); m_Fusex7.EnableWindow(false); m_Fusex8.EnableWindow(false);
}

//Alle Dialogelemente auer "Abbrechen" aktivieren
void CAVRPromDlg::EnableControls()
{
//Buttons
 m_Burn.EnableWindow(true);
 m_Verify.EnableWindow(true);
 m_Blank.EnableWindow(true);
 m_Save.EnableWindow(true);
 m_NewFile.EnableWindow(true);
 m_Prefs.EnableWindow(true);
 m_Erase.EnableWindow(true);
 m_SendReset.EnableWindow(true);
 m_Default.EnableWindow(true);
//Combos
 m_Manuf.EnableWindow(true);
 m_Device.EnableWindow(true);
//CheckBoxes
 m_BurnVerify.EnableWindow(true);
 m_SaveFF.EnableWindow(true);
 m_Checksum.EnableWindow(true);
 m_CheckID.EnableWindow(true);
 m_Lock1.EnableWindow(true);
 m_Lock2.EnableWindow(true);
//Das Textfenster mit Dateinamen
 m_fname.EnableWindow(true);
 EnableFuses(0);
// m_IntRC.EnableWindow(true);
}

//Findet raus ob der Brenner arbeitet, gibt Meldung aus oder OK
int CAVRPromDlg::CheckDevil()
{
//Wenn der Brenner arbeitet ist immer das kleine Teufelchenfenster auf
//Hiermit stelle ich fest ob es geffnet ist, und verweigere dann
//den Zugriff auf den Brenner
 if(FindWindow(NULL,deviltitle)!=NULL)
  {
   return NO_BURN; //Pseudorckgabecode 
  }
 else return NO_ERRORS;
}

void CAVRPromDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
//Neue Fensterposition merkem
  lastx=xkoord; //Alte Werte merken fr OnSize()
  lasty=ykoord;
  xkoord=x;
  ykoord=y;

}

void CAVRPromDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
//Verhindert das der Menpunkt Maximieren das Fenster
//auf Fullscreen umstellt.
//Bei Minimieren sorgt die Funktion dafr da das Fenster
//nach Klick auf das Programmicon wieder an der alten Stelle
//erscheint

    if(nType==SIZE_MAXIMIZED)
	 {
	  xkoord=lastx; //Alte Werte wiederherstellen
	  ykoord=lasty; //Wurden von OnSize() ber OnMove() gendert
	  //Alte Gre und Position wiederherstellen
	  SetWindowPos(NULL,lastx,lasty,width,height,NULL);
	 }

    if(nType==SIZE_MINIMIZED)
	 {
	  xkoord=lastx; //Alte Werte wiederherstellen
	  ykoord=lasty; //Wurden von OnSize() ber OnMove() gendert
	 }
}

//Kurzfristig so viel Rechenzeit wie mglich holen
void CAVRPromDlg::MoreCPUTime()
{
    HANDLE myprocess,mythread;

	myprocess=GetCurrentProcess();
	mythread=GetCurrentThread();

    if(winversion>=WIN_NT351) //Wenn Prioritt unter NT zu hoch, bewegt sich nicht
						   //einmal mehr der Mauszeiger !!
	 {
	  SetPriorityClass(myprocess,HIGH_PRIORITY_CLASS);  //Sonst kein abbrechen unter NT mglich
 	  SetThreadPriority(mythread,THREAD_PRIORITY_HIGHEST);
	 }
    else //Alle anderen wie Win95,Win98
	 {
	  SetPriorityClass(myprocess,REALTIME_PRIORITY_CLASS);
	  SetThreadPriority(mythread,THREAD_PRIORITY_TIME_CRITICAL);
	  //Ergibt ProcessPriority 24 !!
	  //ThreadPriority 39 !!
	 }

}

//Rechenzeit auf normal zurckschalten
void CAVRPromDlg::NormalCPUTime()
{
    HANDLE myprocess,mythread;
    BOOL result;

	myprocess=GetCurrentProcess();
	result=SetPriorityClass(myprocess,NORMAL_PRIORITY_CLASS);
	mythread=GetCurrentThread();
	SetThreadPriority(mythread,THREAD_PRIORITY_NORMAL);
	//Ergibt ProcessPriority 8 !!
	//ThreadPriority 8 !!
}

//Security und Fusebits de/aktivieren je nach Chip
void CAVRPromDlg::EnableFuses(int defaults) 
{
 //Erstmal alle Fuses und deren Namen lschen
   SetDlgItemText(IDC_FUSE1,"----"); SetDlgItemText(IDC_FUSE2,"----"); SetDlgItemText(IDC_FUSE3,"----"); SetDlgItemText(IDC_FUSE4,"----");
   SetDlgItemText(IDC_FUSE5,"----"); SetDlgItemText(IDC_FUSE6,"----"); SetDlgItemText(IDC_FUSE7,"----"); SetDlgItemText(IDC_FUSE8,"----");

   SetDlgItemText(IDC_FUSEHI1,"----"); SetDlgItemText(IDC_FUSEHI2,"----"); SetDlgItemText(IDC_FUSEHI3,"----"); SetDlgItemText(IDC_FUSEHI4,"----");
   SetDlgItemText(IDC_FUSEHI5,"----"); SetDlgItemText(IDC_FUSEHI6,"----"); SetDlgItemText(IDC_FUSEHI7,"----"); SetDlgItemText(IDC_FUSEHI8,"----");

   SetDlgItemText(IDC_FUSEX1,"----"); SetDlgItemText(IDC_FUSEX2,"----"); SetDlgItemText(IDC_FUSEX3,"----"); SetDlgItemText(IDC_FUSEX4,"----");
   SetDlgItemText(IDC_FUSEX5,"----"); SetDlgItemText(IDC_FUSEX6,"----"); SetDlgItemText(IDC_FUSEX7,"----"); SetDlgItemText(IDC_FUSEX8,"----");

   SetDlgItemText(IDC_LOCK1,"Lock1"); SetDlgItemText(IDC_LOCK2,"Lock2"); //Immer vorhanden
   SetDlgItemText(IDC_LOCK3,"----"); SetDlgItemText(IDC_LOCK4,"----"); SetDlgItemText(IDC_LOCK5,"----"); SetDlgItemText(IDC_LOCK6,"----");
   SetDlgItemText(IDC_LOCK7,"----"); SetDlgItemText(IDC_LOCK8,"----");

   //Erstmal alle Fuses deaktivieren
   m_Lock3.EnableWindow(false); m_Lock4.EnableWindow(false); m_Lock5.EnableWindow(false); m_Lock6.EnableWindow(false);
   m_Lock7.EnableWindow(false); m_Lock8.EnableWindow(false);
   m_Fuse1.EnableWindow(false); m_Fuse2.EnableWindow(false); m_Fuse3.EnableWindow(false); m_Fuse4.EnableWindow(false);
   m_Fuse5.EnableWindow(false); m_Fuse6.EnableWindow(false); m_Fuse7.EnableWindow(false); m_Fuse8.EnableWindow(false);
   m_Fusehi1.EnableWindow(false); m_Fusehi2.EnableWindow(false); m_Fusehi3.EnableWindow(false); m_Fusehi4.EnableWindow(false);
   m_Fusehi5.EnableWindow(false); m_Fusehi6.EnableWindow(false); m_Fusehi7.EnableWindow(false); m_Fusehi8.EnableWindow(false);
   m_Fusex1.EnableWindow(false); m_Fusex2.EnableWindow(false); m_Fusex3.EnableWindow(false); m_Fusex4.EnableWindow(false);
   m_Fusex5.EnableWindow(false); m_Fusex6.EnableWindow(false); m_Fusex7.EnableWindow(false); m_Fusex8.EnableWindow(false);

 //Einstellungen fr SPI !
 if(program_mode==SPI1 || program_mode==MSPI1)
  {

 switch(device) //Check fr mich ob Baustein eingetragen ist
  {
   case S1200: case S2313: case S2323: case S2343:
   case S4414: case S8515: case S2333: case S4433:
   case S4434: case S8535:
   case TINY12: case TINY13: case TINY15: case TINY26:
//   case Tiny22: //Geht hier nicht wegen S2343, macht aber nix
   case TINY25: case TINY45: case TINY85:
   case TINY2313:
   case MEGA103: case MEGA161:  case MEGA163:
   case MEGA603: case MEGA8:    case MEGA16:
   case MEGA64:  case MEGA323:  case MEGA128:
   case MEGA162: case MEGA8515: case MEGA8535:
   case MEGA165: case MEGA169: case MEGA32:
   case MEGA48:  case MEGA88:   case MEGA168:
   case MEGA325: case MEGA3250: //auch 329,3290
   case MEGA645: case MEGA6450: //auch 649,6490
   case MEGA640: case MEGA1280:   case MEGA1281:
   case MEGA644: case MEGA2560:  case MEGA2561:
   case AT90CAN128:
	   break;
   default:
      sprintf(zeile,"Devicecode 0x%04X fehlt in EnableFuses SPI",device);
      Msg(zeile);
   break;
  }

 if(device==TINY12)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"RSTDISBL"); SetDlgItemText(IDC_FUSE6,"SPIEN");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(false); m_Fuse6.EnableWindow(false);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);
  }

 if(device==TINY13)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fusehigh|=0xE0;
      
   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"SUT0"); SetDlgItemText(IDC_FUSE4,"SUT1");
   SetDlgItemText(IDC_FUSE5,"CKDIV8"); SetDlgItemText(IDC_FUSE6,"WDTON");
   SetDlgItemText(IDC_FUSE7,"EESAVE"); SetDlgItemText(IDC_FUSE8,"SPIEN");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(false);

   SetDlgItemText(IDC_FUSEHI1,"RSTDISBL"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL0");
   SetDlgItemText(IDC_FUSEHI3,"BODLEVEL1"); SetDlgItemText(IDC_FUSEHI4,"DWEN");
   SetDlgItemText(IDC_FUSEHI5,"SPMEN");

   m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
  }

 if(device==TINY15)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0x0C;
      
   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE5,"RSTDISBL"); SetDlgItemText(IDC_FUSE6,"SPIEN");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse5.EnableWindow(false); m_Fuse6.EnableWindow(false);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);
  }

 if(device==TINY2313)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fusehigh|=0x01; //RSTDISBL aus
   fusex|=0xFE;

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"RSTDISBL"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL0");
   SetDlgItemText(IDC_FUSEHI3,"BODLEVEL1"); SetDlgItemText(IDC_FUSEHI4,"BODLEVEL2");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");    SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"EESAVE");   SetDlgItemText(IDC_FUSEHI8,"DWEN");

   SetDlgItemText(IDC_FUSEX1,"SELFPRGEN");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(false); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true); m_Fusehi6.EnableWindow(true); 
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(true);
  }

 if(device==TINY26)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fusehigh|=0xE0;
      
   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOPT"); SetDlgItemText(IDC_FUSE8,"PLLCK");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   SetDlgItemText(IDC_FUSEHI1,"BODEN"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL");
   SetDlgItemText(IDC_FUSEHI3,"EESAVE"); SetDlgItemText(IDC_FUSEHI4,"SPIEN");
   SetDlgItemText(IDC_FUSEHI5,"RSTDISBL");

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true);
//   m_Fusehi5.EnableWindow(true);
  }

 if(device==TINY25 || device==TINY45 || device==TINY85)
  {
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fusehigh|=0x80; //ResetPin,SPIEN,WDT-off,Debug-off
   fusex|=0xFE;	  //nur D0 gltig	

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BODLEVEL0"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL1");
   SetDlgItemText(IDC_FUSEHI3,"BODLEVEL2"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");   
   SetDlgItemText(IDC_FUSEHI5,"WDTON");    SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"DWEN"); SetDlgItemText(IDC_FUSEHI8,"RSTDISBL"); 

   SetDlgItemText(IDC_FUSEX1,"SELFPRGEN");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true); m_Fusehi6.EnableWindow(true); 
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(false);

   m_Fusex1.EnableWindow(true);
  }

 if(   device==S1200 || device==S2313 || device==S4414 || device==S8515
    || device==TINY22 )
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
  }

 if(device==S2323)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0xFE;  //Nur RCEn vorhanden

   SetDlgItemText(IDC_FUSE1,"FSTRT");
   m_Fuse1.EnableWindow(true);
  }

 if(device==S2343)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0xFE;  //Nur RCEn vorhanden

   SetDlgItemText(IDC_FUSE1,"RCEN");
   m_Fuse1.EnableWindow(true);
  }

 if(device==S2333 || device==S4433)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0xE0;  //D0..4 vorhanden

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"BODEN");
   SetDlgItemText(IDC_FUSE5,"BODLEVEL");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true);
  }

 if(device==S4434 || device==S8535)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0xFE;  //Nur FSTRT vorhanden

   SetDlgItemText(IDC_FUSE1,"FSTRT");
   m_Fuse1.EnableWindow(true);
  }

 if(device==MEGA103 || device==MEGA603)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur Lock1,Lock2 vorhanden
   fuselow|=0xF4;  


   SetDlgItemText(IDC_FUSE1,"SUT0"); SetDlgItemText(IDC_FUSE2,"SUT1");
   SetDlgItemText(IDC_FUSE4,"EESAVE");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse4.EnableWindow(true);
  }

 if(device==MEGA8515 || device==MEGA8535)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"CKOPT");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"WDTON");

   if(device==MEGA8515) SetDlgItemText(IDC_FUSEHI8,"S8515C");
   if(device==MEGA8535) SetDlgItemText(IDC_FUSEHI8,"S8535C");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);
  }

 if(device==MEGA161)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fuselow|=0xA0;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"BODEN");
   SetDlgItemText(IDC_FUSE5,"BODLEVEL");
   SetDlgItemText(IDC_FUSE7,"BOOTRST");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse7.EnableWindow(true);
  }

 if(device==MEGA162)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fusex|=0xE1;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV16");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX2,"BODLEVL0"); SetDlgItemText(IDC_FUSEX3,"BODLEVL1");
   SetDlgItemText(IDC_FUSEX4,"BODLEVL2"); SetDlgItemText(IDC_FUSEX5,"M161C");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex2.EnableWindow(true); m_Fusex3.EnableWindow(true);
   m_Fusex4.EnableWindow(true); m_Fusex5.EnableWindow(true);
 }

 if(device==MEGA163)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fuselow|=0x30;
   fusehigh|=0xF8;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true);
  }

 if(device==MEGA165)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fusex|=0xF1;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"RESERVED"); SetDlgItemText(IDC_FUSEX2,"BODLEVL0");
   SetDlgItemText(IDC_FUSEX3,"BODLEVL1"); SetDlgItemText(IDC_FUSEX4,"BODLEVL2");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(false); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true); m_Fusex4.EnableWindow(true);
  }

 if(device==MEGA169)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fusex|=0xF0;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"RSTDISBL"); SetDlgItemText(IDC_FUSEX2,"BODLEVL0");
   SetDlgItemText(IDC_FUSEX3,"BODLEVL1"); SetDlgItemText(IDC_FUSEX4,"BODLEVL2");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(true); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true); m_Fusex4.EnableWindow(true);
  }

 if(device==MEGA8)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"CKOPT");
   SetDlgItemText(IDC_FUSEHI7,"WDTON"); SetDlgItemText(IDC_FUSEHI8,"RSTDISBL");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(false);
  }

 if(device==MEGA16 || device==MEGA32)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"CKOPT");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);
  }

 if(device==MEGA323)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fuselow|=0x30;
   fusehigh|=0x30;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);
  }

  if(device==MEGA64 || device==MEGA128)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fusex|=0xFC;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"BODEN"); SetDlgItemText(IDC_FUSE8,"BODLEVEL");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"CKOPT");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"WDTON"); SetDlgItemText(IDC_FUSEX2,"M103C");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(true); m_Fusex2.EnableWindow(true);
  }

 if(device==MEGA48)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xFC; //Nur lock1, lock2 
   fusehigh|=0x80; // don't allow to program RSTDISBL
   fusex|=0xFE;

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BODLEVEL0"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL1");
   SetDlgItemText(IDC_FUSEHI3,"BODLEVEL2"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"DWEN"); SetDlgItemText(IDC_FUSEHI8,"RSTDISBL");

   SetDlgItemText(IDC_FUSEX1,"SELFPRGEN");

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true); 
   m_Fusehi7.EnableWindow(true);

   m_Fusex1.EnableWindow(true);
  }

 if(device==MEGA88 || device==MEGA168)
  {
   //Und zur Sicherheit einen Filter um unbenutzte Bits auf 1 zu setzen
   lockbits|=0xC0;
   fusehigh|=0x80; // don't allow to program RSTDISBL
   fusex|=0xF8;

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BODLEVEL0"); SetDlgItemText(IDC_FUSEHI2,"BODLEVEL1");
   SetDlgItemText(IDC_FUSEHI3,"BODLEVEL2"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"DWEN"); SetDlgItemText(IDC_FUSEHI8,"RSTDISBL");

   SetDlgItemText(IDC_FUSEX1,"BOOTRST"); SetDlgItemText(IDC_FUSEX2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEX3,"BOOTSZ1");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true); 
   m_Fusehi7.EnableWindow(true);

   m_Fusex1.EnableWindow(true); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true);
  }

//Auch fr MEGA329,3290,649,6490
 if(device==MEGA325 || device==MEGA3250 || device==MEGA645 || device==MEGA6450)
  {
   lockbits|=0xC0;
   fusex|=0xF9;   //11111001 RSTDISBL deactivated

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"RSTDISBL"); SetDlgItemText(IDC_FUSEX2,"BODLEVL0");
   SetDlgItemText(IDC_FUSEX3,"BODLEVL1");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(false); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true);
  }

 if(   device==MEGA640  || device==MEGA1280  || device==MEGA1281
    || device==MEGA644  || device==MEGA2560 || device==MEGA2561)
  {
   lockbits|=0xC0;
   fusex|=0xF8;   //11111000

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"BODLEVL0");
   SetDlgItemText(IDC_FUSEX2,"BODLEVL1"); SetDlgItemText(IDC_FUSEX3,"BODLEVL2");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(true); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true);
  }

 if(device==AT90CAN128)
  {
   lockbits|=0xC0;
   fusex|=0xF1;   //11110001

   SetDlgItemText(IDC_LOCK3,"BLB01"); SetDlgItemText(IDC_LOCK4,"BLB02");
   SetDlgItemText(IDC_LOCK5,"BLB11"); SetDlgItemText(IDC_LOCK6,"BLB12");

   SetDlgItemText(IDC_FUSE1,"CKSEL0"); SetDlgItemText(IDC_FUSE2,"CKSEL1");
   SetDlgItemText(IDC_FUSE3,"CKSEL2"); SetDlgItemText(IDC_FUSE4,"CKSEL3");
   SetDlgItemText(IDC_FUSE5,"SUT0"); SetDlgItemText(IDC_FUSE6,"SUT1");
   SetDlgItemText(IDC_FUSE7,"CKOUT"); SetDlgItemText(IDC_FUSE8,"CKDIV8");

   SetDlgItemText(IDC_FUSEHI1,"BOOTRST"); SetDlgItemText(IDC_FUSEHI2,"BOOTSZ0");
   SetDlgItemText(IDC_FUSEHI3,"BOOTSZ1"); SetDlgItemText(IDC_FUSEHI4,"EESAVE");
   SetDlgItemText(IDC_FUSEHI5,"WDTON");   SetDlgItemText(IDC_FUSEHI6,"SPIEN");
   SetDlgItemText(IDC_FUSEHI7,"JTAGEN"); SetDlgItemText(IDC_FUSEHI8,"OCDEN");

   SetDlgItemText(IDC_FUSEX1,"TA0SEL");   SetDlgItemText(IDC_FUSEX2,"BODLEVL0");
   SetDlgItemText(IDC_FUSEX3,"BODLEVL1"); SetDlgItemText(IDC_FUSEX4,"BODLEVL2");

   m_Lock3.EnableWindow(true); m_Lock4.EnableWindow(true);
   m_Lock5.EnableWindow(true); m_Lock6.EnableWindow(true);

   m_Fuse1.EnableWindow(true); m_Fuse2.EnableWindow(true);
   m_Fuse3.EnableWindow(true); m_Fuse4.EnableWindow(true);
   m_Fuse5.EnableWindow(true); m_Fuse6.EnableWindow(true);
   m_Fuse7.EnableWindow(true); m_Fuse8.EnableWindow(true);

   m_Fusehi1.EnableWindow(true); m_Fusehi2.EnableWindow(true);
   m_Fusehi3.EnableWindow(true); m_Fusehi4.EnableWindow(true);
   m_Fusehi5.EnableWindow(true);
   m_Fusehi7.EnableWindow(true); m_Fusehi8.EnableWindow(true);

   m_Fusex1.EnableWindow(false); m_Fusex2.EnableWindow(true);
   m_Fusex3.EnableWindow(true);  m_Fusex4.EnableWindow(true);
  }

  }// if(program_mode==SPI1 || program_mode==MSPI1)
//Ende SPI Programmierung

//Dieses merkwrdige (~lockbits)&0x01 weil die Bits Lowaktiv sind ! 
 CheckDlgButton( IDC_LOCK1, (~lockbits)&0x01 ); CheckDlgButton( IDC_LOCK2, (~lockbits)&0x02 );
 CheckDlgButton( IDC_LOCK3, (~lockbits)&0x04 ); CheckDlgButton( IDC_LOCK4, (~lockbits)&0x08 );
 CheckDlgButton( IDC_LOCK5, (~lockbits)&0x10 ); CheckDlgButton( IDC_LOCK6, (~lockbits)&0x20 );
 CheckDlgButton( IDC_LOCK7, (~lockbits)&0x40 ); CheckDlgButton( IDC_LOCK8, (~lockbits)&0x80 );

 CheckDlgButton( IDC_FUSE1, (~fuselow)&0x01 ); CheckDlgButton( IDC_FUSE2, (~fuselow)&0x02);
 CheckDlgButton( IDC_FUSE3, (~fuselow)&0x04 ); CheckDlgButton( IDC_FUSE4, (~fuselow)&0x08 );
 CheckDlgButton( IDC_FUSE5, (~fuselow)&0x10 ); CheckDlgButton( IDC_FUSE6, (~fuselow)&0x20 );
 CheckDlgButton( IDC_FUSE7, (~fuselow)&0x40 ); CheckDlgButton( IDC_FUSE8, (~fuselow)&0x80 );

 CheckDlgButton( IDC_FUSEHI1, (~fusehigh)&0x01 ); CheckDlgButton( IDC_FUSEHI2, (~fusehigh)&0x02 );
 CheckDlgButton( IDC_FUSEHI3, (~fusehigh)&0x04 ); CheckDlgButton( IDC_FUSEHI4, (~fusehigh)&0x08 );
 CheckDlgButton( IDC_FUSEHI5, (~fusehigh)&0x10 ); CheckDlgButton( IDC_FUSEHI6, (~fusehigh)&0x20 );
 CheckDlgButton( IDC_FUSEHI7, (~fusehigh)&0x40 ); CheckDlgButton( IDC_FUSEHI8, (~fusehigh)&0x80 );

 CheckDlgButton( IDC_FUSEX1, (~fusex)&0x01 ); CheckDlgButton( IDC_FUSEX2, (~fusex)&0x02);
 CheckDlgButton( IDC_FUSEX3, (~fusex)&0x04 ); CheckDlgButton( IDC_FUSEX4, (~fusex)&0x08 );
 CheckDlgButton( IDC_FUSEX5, (~fusex)&0x10 ); CheckDlgButton( IDC_FUSEX6, (~fusex)&0x20 );
 CheckDlgButton( IDC_FUSEX7, (~fusex)&0x40 ); CheckDlgButton( IDC_FUSEX8, (~fusex)&0x80 );

 UpdateWindow();
}

//#############################################
//Security und Fusebits Defaults je nach Chip
void CAVRPromDlg::SetDefaultFuses() 
//#############################################
{
 //Erstmal alle Fuses aus
 lockbits=0xFF; fuselow=0xFF; fusehigh=0xFF; fusex=0xFF;

//Generelle Grundeinstellungen
//RC Osci bei AVR/ATiny in DIP8
//Quarz Osci bei allen anderen
//BODEN aktiviert wenn vorhanden
//BODLEVL auf den hchsten Wert
//Lngste Startupzeit
//Watchdog aus
//SPIEN kann nicht deaktiviert werden und ist immer 0
//JTAGEN immer aus
//OCDEN immer aus

 //Einstellungen fr SPI !
 if(program_mode==SPI1 || program_mode==MSPI1)
  {

 switch(device) //Check fr mich ob Baustein eingetragen ist
  {
   case S1200: case S2313: case S2323: case S2343:
   case S4414: case S8515: case S2333: case S4433:
   case S4434: case S8535:
   case TINY12: case TINY13: case TINY15: case TINY26:
//   case Tiny22: //Geht hier nicht wegen S2343, macht aber nix
   case TINY2313:   case TINY25: case TINY45: case TINY85:
   case MEGA103: case MEGA161:  case MEGA163:
   case MEGA603: case MEGA8:    case MEGA16:
   case MEGA64:  case MEGA323:  case MEGA128:
   case MEGA162: case MEGA8515: case MEGA8535:
   case MEGA165: case MEGA169: case MEGA32:
   case MEGA48:  case MEGA88:   case MEGA168:
   case MEGA325: case MEGA3250: //auch 329,3290
   case MEGA645: case MEGA6450: //auch 649,6490
   case MEGA640: case MEGA1280:   case MEGA1281:
   case MEGA644: case MEGA2560:  case MEGA2561:
   case AT90CAN128:
      break;
   default:
      sprintf(zeile,"Devicecode 0x%04X fehlt in SetDefaultFuses SPI",device);
      Msg(zeile);
   break;
  }

 if(device==TINY25 || device==TINY45 || device==TINY85)
  {
   fuselow=0xE2;  //CKSEL auf int RC.Osci 
   fusehigh=0xDF; //ResetPin,SPIEN,WDT-off,Debug-off
   fusex=0xFF;
  }

 if(device==TINY12)
  {
   fuselow=0x92;  //BODEN-LEVEL,SPI aktiv, Reset Pin, CKSEL auf int RC.Osci 
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==TINY13)
  {
   fuselow=0x6A;  //01101010 SPI aktiv,EESAVE aus, CKDIV an,WDT,aus, CKSEL auf int RC.Osci 
   fusehigh=0xF9;   //11111001 SPM+debugWire disable, ResetPin, BODLEVEL 4,3V
   fusex=0xFF;
  }

 if(device==TINY15)
  {
   fuselow=0x1C;  //BODEN-LEVEL,SPI aktiv,Reset Pin, CKSEL0,1 =0 
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==TINY2313)
  {
	 fuselow=0xDF; //00011100 Quarz-Osci, BOD enabled 
	 fusehigh=0xD9;
	 fusex=0xFF;
  }

 if(device==TINY26)
  {
   fuselow=0xDF;  //11011111 PLL aus, Quarz 3-16MHz, BOD enabled, CKOPT aus 
   fusehigh=0xF4; //11110100 Reset Pin,SPIEN an, EEPROM Write, BODLEVEL=4V, BOD aktiv
   fusex=0xFF;
  }

 if(   device==S1200 || device==S2313 || device==S4414 || device==S8515
    || device==TINY22 )
  {
   fuselow=0xFF;
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==S2323)
  {
   fuselow=0xFE; //Standard RC-Osci einschalten
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==S2343)
  {
   fuselow=0xFE; //Standard RC-Osci einschalten
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==S2333 || device==S4433)
  {
   fuselow=0xFA; //BODxx off, CKSEL=010
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==S4434 || device==S8535)
  {
   fuselow=0xFF;
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==MEGA8515 || device==MEGA8535)
  {
   fuselow=0x3F; //Quarz-Osci 00111111
   fusehigh=0xD9; //11011001
   fusex=0xFF;   
  }

 if(device==MEGA103 || device==MEGA603)
  {
   fuselow=0xFF;
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==MEGA161)
  {
   fuselow=0xC4; //11000100
   fusehigh=0xFF;
   fusex=0xFF;
  }

 if(device==MEGA162)
  {
   fuselow=0xDF; //Quarz-Osci >8MHz, CKDIV aus 11011111
   fusehigh=0xD9; //JTAGEN aus ! 11011001
   fusex=0xF9;    //Bodlevel 4.3V
  }

 if(device==MEGA163)
  {
	 fuselow=0x1C; //Quarz-Osci 00011100
	 fusehigh=0xFF;
	 fusex=0xFF;
  }

 if(device==MEGA165)
  {
   fuselow=0xDF;  //11011111 CKDIV aus, BOD Enable, Quarz >=8MHz
   fusehigh=0xD9; //11011001
   fusex=0xF9;	  //BOD 4.5V
  }

 if(device==MEGA169)
  {
   fuselow=0xDF;  //CKDIV aus, BOD Enable, Qaurz >=8MHz 11011111
   fusehigh=0xD9; //11011001
   fusex=0xFF;
  }

 if(device==MEGA8 || device==MEGA16 || device==MEGA32)
  {
   fuselow=0x1F; //00011111
   fusehigh=0xD9;//11011001
   fusex=0xFF;
  }

 if(device==MEGA323)
  {
    fuselow=0x3C; //00111100
    fusehigh=0xDF;//11011111
    fusex=0xFF;
  }

 if(device==MEGA64 || device==MEGA128)
  {
	 fuselow=0x1F; //00011111
	 fusehigh=0xD9;//11011001
     fusex=0xFF;   //11111111 WDT-off/ nicht Mega103 kompatibel
  }

//Auch fr MEGA329,3290,649,6490
 if(device==MEGA325 || device==MEGA3250 || device==MEGA645 || device==MEGA6450)
  {
   fuselow=0xDF;  //11011111 CKDIV off, BOD Enable, Quarz >=8MHz
   fusehigh=0xD9; //11011001 OCD off,JTAG off,SPI on, no WDT, EESAVE off
   fusex=0xF9;    //11111001 BOD 4.3V, RSTDISBL deactivated
  }

 if(   device==MEGA640  || device==MEGA1280  || device==MEGA1281
    || device==MEGA2560 || device==MEGA2561)
  {
   fuselow=0xDF;  //11011111 CKDIV off, BOD Enable, Quarz >=8MHz
   fusehigh=0xD9; //11011001 OCD off,JTAG off,SPI on, no WDT, EESAVE off
   fusex=0xFC;    //11111001 BOD 4.3V
  }

 if(device==MEGA644)
  {
   fuselow=0xE7;  //11100111 CKDIV off, no CLKOUT,max. Startuptime, Quarz >=8MHz,
   fusehigh=0xD9; //11011001 OCD off,JTAG off,SPI on, no WDT, EESAVE off
   fusex=0xFC;    //11111100 BOD 4.3V
  }

 if(device==MEGA48 || device==MEGA88 || device==MEGA168)
  {
   fuselow=0xEF; //11101111
   fusehigh=0xDF;//11011111
   fusex=0xFF;
  }

 if(device==AT90CAN128)
  {
   fuselow=0xDF; //11011111 CKDIV off, no CLKOUT,max. Startuptime, Quarz >=8MHz, BOD enabled
   fusehigh=0xDF;//11011111 OCD off,JTAG off, SPIEN on, WDT off, EESAVE off, no Boot
   fusex=0xFD;   //11111101 BOD 4.1V
  }
  }// if(program_mode==SPI1 || program_mode==MSPI1)
//Ende SPI Programmierung

}

//#####################################
void CAVRPromDlg::OnDefaultFuses() 
//#####################################
{
 SetDefaultFuses();
 EnableFuses(0);  //Fuses einstellen
}

//Beginn Lockbits
void CAVRPromDlg::OnLock1() 
//********************************************************************
{
 lock1=IsDlgButtonChecked(IDC_LOCK1);
//Lock1,2 sind Lowaktiv !!

 if(lock1==0)
  {
   lockbits|=0x03; //lock1,2 lschen bzw. auf 1 setzen
   lock2=0; //Immer nur beide gleichzeitig
   CheckDlgButton( IDC_LOCK2, lock2 ); //Control Updaten
  }
 else lockbits&=~0x01; //lock1 brennen
}

void CAVRPromDlg::OnLock2() 
{
 lock2=IsDlgButtonChecked(IDC_LOCK2);
//Lock1,2 sind Lowaktiv !!

 if(lock2==1)
  {
   lockbits&=~0x03; //lock1,2 brennen bzw. auf 0 setzen
   lock1=1; //Immer nur beide gleichzeitig
   CheckDlgButton( IDC_LOCK1, lock1 ); //Control Updaten
  }
  else lockbits|=0x02; //lock2 lschen bzw. auf 1 setzen
}

void CAVRPromDlg::OnLock3() { if(IsDlgButtonChecked(IDC_LOCK3)) lockbits&=~0x04; else lockbits|=0x04; }
void CAVRPromDlg::OnLock4() { if(IsDlgButtonChecked(IDC_LOCK4)) lockbits&=~0x08; else lockbits|=0x08; }
void CAVRPromDlg::OnLock5() { if(IsDlgButtonChecked(IDC_LOCK5)) lockbits&=~0x10; else lockbits|=0x10; }
void CAVRPromDlg::OnLock6() { if(IsDlgButtonChecked(IDC_LOCK6)) lockbits&=~0x20; else lockbits|=0x20; }
void CAVRPromDlg::OnLock7() { if(IsDlgButtonChecked(IDC_LOCK7)) lockbits&=~0x40; else lockbits|=0x40; }
void CAVRPromDlg::OnLock8() { if(IsDlgButtonChecked(IDC_LOCK8)) lockbits&=~0x80; else lockbits|=0x80; }

//Low Fuses
void CAVRPromDlg::OnFuse1() { if(IsDlgButtonChecked(IDC_FUSE1)) fuselow&=~0x01; else fuselow|=0x01; }
void CAVRPromDlg::OnFuse2() { if(IsDlgButtonChecked(IDC_FUSE2)) fuselow&=~0x02; else fuselow|=0x02; }
void CAVRPromDlg::OnFuse3() { if(IsDlgButtonChecked(IDC_FUSE3)) fuselow&=~0x04; else fuselow|=0x04; }
void CAVRPromDlg::OnFuse4() { if(IsDlgButtonChecked(IDC_FUSE4)) fuselow&=~0x08; else fuselow|=0x08; }
void CAVRPromDlg::OnFuse5() { if(IsDlgButtonChecked(IDC_FUSE5)) fuselow&=~0x10; else fuselow|=0x10; }
void CAVRPromDlg::OnFuse6() { if(IsDlgButtonChecked(IDC_FUSE6)) fuselow&=~0x20; else fuselow|=0x20; }
void CAVRPromDlg::OnFuse7() { if(IsDlgButtonChecked(IDC_FUSE7)) fuselow&=~0x40; else fuselow|=0x40; }
void CAVRPromDlg::OnFuse8() { if(IsDlgButtonChecked(IDC_FUSE8)) fuselow&=~0x80; else fuselow|=0x80; }

//High Fuses
void CAVRPromDlg::OnFusehi1() { if(IsDlgButtonChecked(IDC_FUSEHI1)) fusehigh&=~0x01; else fusehigh|=0x01; }
void CAVRPromDlg::OnFusehi2() { if(IsDlgButtonChecked(IDC_FUSEHI2)) fusehigh&=~0x02; else fusehigh|=0x02; }
void CAVRPromDlg::OnFusehi3() { if(IsDlgButtonChecked(IDC_FUSEHI3)) fusehigh&=~0x04; else fusehigh|=0x04; }
void CAVRPromDlg::OnFusehi4() { if(IsDlgButtonChecked(IDC_FUSEHI4)) fusehigh&=~0x08; else fusehigh|=0x08; }
void CAVRPromDlg::OnFusehi5() { if(IsDlgButtonChecked(IDC_FUSEHI5)) fusehigh&=~0x10; else fusehigh|=0x10; }
void CAVRPromDlg::OnFusehi6() { if(IsDlgButtonChecked(IDC_FUSEHI6)) fusehigh&=~0x20; else fusehigh|=0x20; }
void CAVRPromDlg::OnFusehi7() { if(IsDlgButtonChecked(IDC_FUSEHI7)) fusehigh&=~0x40; else fusehigh|=0x40; }
void CAVRPromDlg::OnFusehi8() { if(IsDlgButtonChecked(IDC_FUSEHI8)) fusehigh&=~0x80; else fusehigh|=0x80; }

//Extended Fuses
void CAVRPromDlg::OnFusex1() { if(IsDlgButtonChecked(IDC_FUSEX1)) fusex&=~0x01; else fusex|=0x01; }
void CAVRPromDlg::OnFusex2() { if(IsDlgButtonChecked(IDC_FUSEX2)) fusex&=~0x02; else fusex|=0x02; }
void CAVRPromDlg::OnFusex3() { if(IsDlgButtonChecked(IDC_FUSEX3)) fusex&=~0x04; else fusex|=0x04; }
void CAVRPromDlg::OnFusex4() { if(IsDlgButtonChecked(IDC_FUSEX4)) fusex&=~0x08; else fusex|=0x08; }
void CAVRPromDlg::OnFusex5() { if(IsDlgButtonChecked(IDC_FUSEX5)) fusex&=~0x10; else fusex|=0x10; }
void CAVRPromDlg::OnFusex6() { if(IsDlgButtonChecked(IDC_FUSEX6)) fusex&=~0x20; else fusex|=0x20; }
void CAVRPromDlg::OnFusex7() { if(IsDlgButtonChecked(IDC_FUSEX7)) fusex&=~0x40; else fusex|=0x40; }
void CAVRPromDlg::OnFusex8() { if(IsDlgButtonChecked(IDC_FUSEX8)) fusex&=~0x80; else fusex|=0x80; }

void CAVRPromDlg::OnBurnverify() 
{
 burnverify=IsDlgButtonChecked(IDC_BURNVERIFY);
}

void CAVRPromDlg::OnSendreset() 
{
 //Wenn Brenner arbeitet kann Aktion nicht gestartet werden
 if(CheckDevil()!=NO_ERRORS) return;

 devil.Create(IDD_DIALOG2); //Das kleine Teufelchen

 m_Message.SetWindowText("Schaltung Reset");
 DisableControls();
 ISP_ENABLE();

 RESET_OFF();   //Schaltung anhalten
 Wait1ms(1000); //Damit man auch sieht das was passiert ;)
 RESET_ON();    //Schaltung laufen lassen


 ISP_DISABLE();
 EnableControls();

 m_Cancel.EnableWindow(FALSE); //Cancel-Knopf deaktivieren
 mCancel=FALSE; //Grundzustand wiederherstellen
 m_Message.SetWindowText(WAITING);
 devil.DestroyWindow(); //Weg mit dem Teufelchen
}
