//************************************************************************
// ATMEGA im SPI-Modus programmieren
// AVRpromer V1.xx
// Holger Klabunde
// 15.03.2003
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "port_io.h"
#include "protos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CAVRPromDlg::ProgramMegaSerial(int mode)
{
 unsigned long datcounter,adr;
 unsigned long be,bf,i;
 int result;
 unsigned char dbe,dbf;

 datcounter=0;

 result=NO_ERRORS;

 do
  {
   if(mode==8) //EEPROM Daten
    {
     //Wie bei AVR's !
     dbe=data[datcounter];
     if(dbe!=0xFF) //Keine Leerzellen brennen
      {
 	   SPIWriteAVRByte(datcounter,dbe);

       if(burnverify)
        {
         dbf=SPIReadAVRByte(datcounter); //Verify
	     if(dbe!=dbf)
	      {
		   sprintf(zeile,"Daten-EEPROM Fehler !!\nAdresse: 0x%04lX\n\n"
		               "Richtig: 0x%02X\n"
		               "Gelesen: 0x%02X\n"
		         ,datcounter,dbe,dbf);
		   result=MsgRetryCancel(zeile);
		   if(result==IDCANCEL) return NO_BURN;
		   else result=NO_ERRORS; //Weitermachen gewnscht
		  }
        }
      }

     datcounter++; // nchstes Byte im Array
     UpdateProgress();
 	}

   if(mode==16) //Programmspeicher
    {

     for(i=0; i<pagesize; i++) //Eine Page laden !
	  { 
       be=data[datcounter]+(data[datcounter+1]<<8); //Wort zusammenbauen
       adr=datcounter/2; //ATMega Adresse
       testadr=adr;      //Fr die Kontrolle des Leseschutzes
       testword=be;       //Eine Adresse und ein Wort merken
	                      //Eigentlich mte ein komplettes Verify erfolgen !

       //Page mit Worten fllen
       SPILoadPage(adr,(unsigned int)be);
       datcounter+=2; // nchstes Wort im Array
       UpdateProgress();
      }

     SPIWritePage(adr); //Programmierung starten
	 //Ich mach hier jetzt erstmal noch kein Datapolling !
	 //Einfach nur Programmierzeit abwarten
     Wait1ms(progtime); //Programmierzeit abwarten

     if(burnverify)
      {
       bf=SPIReadAVRWord(adr); //Verify eines Bytes der Page
       if(be!=bf)
        {
         sprintf(zeile,"Programmspeicher Fehler !!\nAdresse: 0x%06lX\n\n"
	               "Richtig: 0x%04X\n"
	               "Gelesen: 0x%04X\n"
		         ,adr,be,bf);
	     result=MsgRetryCancel(zeile);
	     if(result==IDCANCEL) return NO_BURN;
	     else result=NO_ERRORS; //Weitermachen gewnscht
 	    }//if(be!=bf)
      }
	}//if(mode==16) //Programmspeicher

  }while((datcounter<highadr)&&(mCancel==FALSE)&&(result==NO_ERRORS));

 if(mCancel==TRUE) return NO_BURN; //Abbruch durch Benutzer
 if(result!=NO_ERRORS) return NO_BURN; //Fehler
 return NO_ERRORS;
}
