#ifndef PROTOS_H
#define PROTOS_H

extern int WindowsVersion();

extern unsigned char Asc2Byte(char *b);
extern unsigned long Asc2Word(char *b,int len);

//Definiert in Global.cpp
extern FILE *in;
extern FILE *out;
extern unsigned char data[];
extern char devicename[];

extern int use_usb,use_lpt;
extern unsigned long usbbaudrate; //Prefs fr USB
extern char usbserial[]; //Prefs fr USB
extern int burnverify; //Prfen beim brennen
extern unsigned long winversion;

//Daten aus der *.CSV-Datei
extern unsigned long maxadr;
extern unsigned long maxeepadr; //Hchste Adresse im Daten EEPROM
extern unsigned int device;    //Devicecode id01,02
extern unsigned char lockbits; //Anzahl der Schutzbits
extern unsigned char fuselow,fusehigh,fusex; //Puffer fr Fusebits

extern unsigned long progtime; // Lnge Programmierimpuls in 100us Steps
extern unsigned long erasetime; //Lschzeit fr EEPROM,FLASH ProgramMemory
extern unsigned char id00,id01,id02; //ID-Daten
extern unsigned long testadr;   //Fr Kontrolle Lockbits
extern unsigned long testword;
extern int program_mode;       //Serielle oder Parallele Programmierung
extern unsigned long pagesize; //Fr ATMEGA
extern unsigned int eeppagesize; //EEprom Pagesize

//Programmierung
extern unsigned long highadr;   //Hchste gefundene Adresse in HEX-Datei
extern unsigned long linecount; //Zeilenzhler fr HEX Dateien

//Werden in ReadIni() gelesen
extern unsigned char checkid; //ID-Check an/aus
extern int DATEN,LESEN,STEUER;
extern long manufindex;  // Herstellerindex  in *.csv Datei
extern long deviceindex; // Bausteinindex in *.csv Datei
extern int beap;        //Peep vor Messges 0=aus , 1=an
extern unsigned long hexlen; //Anzahl Datenbytes einer HEX_Zeile
extern int showdevice; //Bausteindaten anzeigen
extern int no_ff; //LeerBytes schreiben an/aus
extern long xkoord,ykoord;
extern int hexmode;
extern int testcheck; //Checksumme testen an/aus
extern int lock1,lock2; //Die Schutzbits
extern int lastfilter;	//DateiFilter fr NeueDatei, Verify usw.
extern unsigned long slowdown; //LPT Bremse

extern char filename[]; //Die Brenndatei fr Programmdaten
extern char eepname[];  //Die Brenndatei fr EEPROM-Daten
extern char fname[]; //Wie oben, aber ohne Pfad
extern char datapath[]; //nur Pfad

extern char drive[]; //Laufwerk Puiffer
extern char dir[]; //Verzeichnis Puffer
extern char name[]; //Puffer fr Namen
extern char ext[]; //Puffer fr Extension
extern char ininame[]; //Die INI-Datei
extern char zeile[]; //Puffer fr Eingaberoutinen
extern char line[];

extern char csvname[];

extern unsigned char daten;		//Datenport

#endif //PROTOS_H
