//************************************************************************
// Liest die Bauteilbibliothek
//
// Holger Klabunde
// 06.08.2005
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int ParseData();

char zbuff[ARRAYSIZE]="";
char zbuff1[ARRAYSIZE]="";
char txt[2]="";

int len, parse; //Fr Zeilenauswertung
unsigned long realvpp_prog;
unsigned long realvcc_prog;

int CAVRPromDlg::ReadCSV()
{
// Baustein gefunden. Steht jetzt in 'zeile'
// In dieser Zeile stehen in aufgefhrter Reihenfolge folgende Werte:
//
// 01 Bausteinname
// 02 Bausteingehuse fr Auswertung Vcc-Pin
// 03 Programmierspannung Vpp fr Programmiermodus
// 04 Vcc im Programmiermodus
// 05 Programmierzeit
// 06 Lschzeit
// 07 Gre des Programmspeichers
// 08 Gre des EEprombereiches
// 09 ID an Adresse 0x00
// 10 ID an Adresse 0x01
// 11 ID an Adresse 0x02
// Kennzeichen Zeile gltig(Y) oder ungltig(N)


 len=strlen(zeile)-2; 	//Lnge der Bausteinzeile
 parse=0;                    	//Mit erstem Buchstaben anfangen
 txt[1]=0; 					 	//Stringende

 if(ParseData()!=NO_ERRORS) return NO_CSV;
 strcpy(devicename,zbuff); //Bausteinname

 strcpy(line,devicename); //Fr Fehlermeldungen unten
 strcat(line,"\n\n");

// 05 Impulslnge fr Program-Memory
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 progtime=strtoul(zbuff,NULL,0);

 if(progtime>1)
  {
	progtime/=1000;  //Fr grere Brennzeiten
  }

 //Hier spter ber die unterschiedlichen TRIG Kanle noch
 //eine detailiertere(schweres Wort) Auswahl treffen

// 06 Lschzeit fr EEPROM,FLASH Bausteine
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 erasetime=strtoul(zbuff,NULL,0);

 if(erasetime>1) erasetime/=1000;

// 07 Gre des Bausteines in Byte
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 maxadr=strtoul(zbuff,NULL,0)/2; //Durch 2 wegen Wort-Daten nicht Bytes !

 if((maxadr*2)>BLOCKSIZE)
  {
   sprintf(line,
	       "%s\n\n" 
	       "Bausteingre berschreitet %ld (0x%lX) Worte !\n\n"
	       "Bausteine dieser Gre werden nicht untersttzt !\n"
	       ,devicename,BLOCKSIZE,BLOCKSIZE);
   Msg(line);
   return NO_DATA;
  }

 if(maxadr==0)
  {
   sprintf(line,
	       "%s\n\n" 
	       "Bausteingre ist 0 !\n\n in %s"
	       ,devicename,csvname);
   Msg(line);
   return NO_DATA;
  }

// 08 Gre des EEPROM's in Byte
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 maxeepadr=strtoul(zbuff,NULL,0);

 if(maxeepadr>BLOCKSIZE)
  {
   sprintf(line,
	       "%s\n\n" 
	       "Daten EEPROM berschreitet %ld (0x%lX) Bytes !\n\n"
	       "Bausteine dieser Gre werden nicht untersttzt !\n"
	       ,devicename,BLOCKSIZE,BLOCKSIZE);
   Msg(line);
   return NO_DATA;
  }

/*
 if(maxeepadr==0)
  {
   sprintf(line,
	       "%s\n\n" 
	       "Daten EEPROM hat 0 Bytes !\n\n in %s"
	       ,devicename,csvname);
   Msg(line);
   return NO_DATA;
  }
*/

// 09 ID-00
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 id00=(unsigned char)strtoul(zbuff,NULL,0);

// 10 ID-01
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 id01=(unsigned char)strtoul(zbuff,NULL,0);

// 11 ID-02
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 id02=(unsigned char)strtoul(zbuff,NULL,0);

 device=(unsigned int)((id01<<8)+id02); //Devicecode zusammenbauen

 switch(device) //Check fr mich ob Baustein eingetragen ist
  {
   case S1200:   case S2313:   case S2323:   case S2343:
   case S4414:   case S8515:   case S2333:   case S4433:
   case S4434:   case S8535:
   case TINY12:   case TINY13:   case TINY15:
//   case TINY22: //Geht hier nicht wegen S2343, macht aber nix
   case TINY25: case TINY45: case TINY85:
   case TINY26: case TINY2313:
   case MEGA103:
   case MEGA161:   case MEGA162:   case MEGA163: case MEGA165:
   case MEGA169:
   case MEGA603:
   case MEGA48:   case MEGA88:   case MEGA168:
   case MEGA8:
   case MEGA16:
   case MEGA323:   case MEGA32:
   case MEGA325:  case MEGA3250:  //Auch fr 329,3290
   case MEGA64:   case MEGA128:
   case MEGA645:  case MEGA6450:  //Auch fr 649,6490
   case MEGA8515:   case MEGA8535:
   case MEGA640:  case MEGA1280: case MEGA1281:
   case MEGA644: case MEGA2560: case MEGA2561:
   case AT90CAN128:
   break;
   default:
      sprintf(zeile,"Devicecode 0x%04X fehlt in ReadCSV",device);
      Msg(zeile);
    return NO_CSV;
    break;
  }

// 14 Programmiermodus Seriell
 if(ParseData()!=NO_ERRORS) return NO_CSV;

 program_mode=UNKNOWN_MODE;
 if(strcmp(zbuff,"SPI1")==0) program_mode=SPI1;   //AT90 ber ISP-Adapter
 if(strcmp(zbuff,"MSPI1")==0) program_mode=MSPI1; //ATMEGA ber ISP-Adapter
 if(program_mode==UNKNOWN_MODE)
  {
   strcat(line,"Unbekannter Programmiermode !\n\nMode = ");
   strcat(line,zbuff);
   strcat(line,"\n\n");
   strcat(line,csvname);
   Msg(line);
   return NO_CSV; //Unbekannter Programmiermodus
  }

// 18 Pagesize
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 pagesize=strtoul(zbuff,NULL,0);

//EEprom Pagesize
 if(ParseData()!=NO_ERRORS) return NO_CSV;
 eeppagesize=strtoul(zbuff,NULL,0);

/* Blo nicht aktivieren !!!
 if(showdevice>0)
  {
	sprintf(line,
			"Programmierpuls: %ld*100us\n"
			"ProgramErase: %ld*100us\n"
			"ID00,01,02: 0x%02X,0x%02X,0x%02X\n"
			"ProgramMemorySize: 0x%04lX\n"
			"Anzahl LockBits: %d\n"
		  ,devicename
		  ,progtime
		  ,erasetime
		  ,id00,id01,id02
		  ,maxadr
		  ,lockbits
		  );

	MsgBox(line);
  }
*/

 return NO_ERRORS; // Alles OK
}


//Sucht das nchste ';' und hngt solange Buchstaben an zbuff an
int ParseData()
{

 strcpy(zbuff,""); //lschen fr nchsten Wert

 do
  {
	txt[0]=zeile[parse];
	if(txt[0]!=';') strcat(zbuff,txt); //Gehrt zum Wert
	parse++;
  }while((txt[0]!=';')&&(parse<=len));
 if(parse>len) return NO_CSV;

 return NO_ERRORS;
}