//************************************************************************
// Auslesen des Bausteins und sichern in einer BIN oder HEX Datei
// AVRProm V2.xx
//
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"
#include "spi_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CAVRPromDlg::SaveAVR()
{
 int result;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in SaveAVR()");
    return NO_BLANK;
   break;
  }

 result=NO_OUTPUT; //Stimmt bis hier

 if((hexmode==UNKNOWN_HEX)||(hexmode>=LASTHEX))
 {
  Msg("Unbekanntes HEX-Fomat in **avrisp.ini**");
  return NO_OUTPUT;
 }

 ResetProgress(maxadr); //Balken auf Programmspeicher eichen
 
 m_Cancel.EnableWindow(TRUE); //Cancel-Knopf aktivieren
 m_Message.SetWindowText(SAVING);
 UpdateWindow();

 if(checkid>0) //Hersteller und Baustein ID lesen und prfen
  {
	if(CheckID()!=NO_ERRORS) return NO_ID;
  }

 switch(hexmode)
 {
  case INTEL8     : result=SaveHex(filename,16,maxadr); break;
  case INTEL32	  : result=SaveHex(filename,16,maxadr); break;
  case INTELMCS   : result=SaveHex(filename,16,maxadr); break;
  case MOT_S1	  : result=SaveHex(filename,16,maxadr); break;
  case MOT_S2	  : result=SaveHex(filename,16,maxadr); break;
  case MOT_S3	  : result=SaveHex(filename,16,maxadr); break;
  case ATMEL_AVR  : result=SaveROMHex(filename,16,maxadr); break;
  case BIN		  : result=SaveBin(filename,16,maxadr); break;
 }

 m_Percent.SetPos(0); //Statusanzeige zurcksetzen

 if((mCancel==TRUE)||(result!=NO_ERRORS))
  {
   Msg("Speichern abgebrochen !");
   return result;
  }

 if(maxeepadr>0)
  {
   ResetProgress(maxeepadr);

   switch(hexmode)
   {
    case INTEL8   : result=SaveHex(eepname,8,maxeepadr); break;
    case INTEL32  : result=SaveHex(eepname,8,maxeepadr); break;
    case INTELMCS : result=SaveHex(eepname,8,maxeepadr); break;
    case MOT_S1	  : result=SaveHex(eepname,8,maxeepadr); break;
    case MOT_S2	  : result=SaveHex(eepname,8,maxeepadr); break;
    case MOT_S3	  : result=SaveHex(eepname,8,maxeepadr); break;
    case ATMEL_AVR: result=SaveROMHex(eepname,8,maxeepadr); break;
    case BIN	  : result=SaveBin(eepname,8,maxeepadr); break;
   }
  }

 m_Percent.SetPos(0); //Statusanzeige zurcksetzen

 if(mCancel==TRUE)
  { Msg("Speichern abgebrochen !"); }

 Msg("Inhalt vom Baustein gespeichert.");
 return result;
}


