//************************************************************************
// Binrdatei speichern
// Avrprom V1.00 fr Epromer V8.xx
//
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//*****************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"
#include "spi_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Speichert den Inhalt eines Bausteins in einer Binrdatei
int CAVRPromDlg::SaveBin(char *fname, int mode, unsigned long topmem)
{
 unsigned long saved; //int reicht nicht bei fwrite>=32kB !!!
 unsigned long datcounter,counter;
 unsigned long top;
 unsigned long be,blank;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in SaveBin()");
    return NO_BLANK;
   break;
  }

//Wert fr eine Leerzelle je nach mode
 if(mode==8)  blank=0xFF;
 if(mode==16) blank=0xFFFF;
 
 counter=0;

 if(no_ff==0) //LeerBytes sollen nicht in BIN Datei
  {
    m_Message.SetWindowText("Suche Ende des Datenbereiches");
    UpdateWindow();

    counter=topmem; //Hchste Adresse

	do
	 {
	  counter--;	//Eine Adresse weiter unten

      if(mode==8)
	   {
        if(program_mode>=SPI1)
         {
          be=SPIReadAVRByte(counter); //s.o.
         }

	   }//if mode==8

      if(mode==16)
	   {
        if(program_mode>=SPI1)
         {
          be=SPIReadAVRWord(counter); //s.o.
         }

	   }//if mode==16

      progcount++;	//Fr Progressanzeige

	  //Progressanzeige updaten
      if(progcount==steps)
	   {
        PumpMessages(); //Nachrichten von Hand abarbeiten
	    stepcount++;
	    m_Percent.SetPos(RANGE-stepcount); //Balken luft rckwrts !!
	    progcount=0;
	   }

	 }while((counter>0)&&(be==blank)&&(mCancel==FALSE));

	if(counter==topmem-1) top=topmem; //Keine Leerzellen am Ende
	else top=counter+1; //Leerzellen gefunden

    if(mCancel==TRUE) //Knopf abbrechen gedrckt
	 { return NO_OUTPUT; }

/*
	if(top==1) //Nur Leerzellen vorhanden
	 {
      if(mode==8)
	   {
	    Msg("Der Baustein enthlt nur Leerzellen im Datenspeicher!!\n\n"
	        "Speichervorgang abgebrochen.\n\n"
		    "Wenn eine Leerzellen-Datei geschrieben werden\n"
		    "soll, ** Leerzellen speichern ** aktivieren !");
	   }

      if(mode==16)
	   {
	    Msg("Der Baustein enthlt nur Leerzellen im Programmspeicher!!\n\n"
	        "Speichervorgang abgebrochen.\n\n"
		    "Wenn eine Leerzellen-Datei geschrieben werden\n"
		    "soll, ** Leerzellen speichern ** aktivieren !");
	   }

      return NO_OUTPUT;
	 }
*/
	counter=0;
  }
 else
  {
   top=topmem; //Leerbytes sollen geschrieben werden
  }

//Datei ffnen
 if((out=fopen(fname,"w+b"))==NULL)
  { ShowErr(fname); return NO_OUTPUT; }


 ResetProgress(top);
 m_Message.SetWindowText(SAVING);
 UpdateWindow();

 do
  {
	datcounter=0; //Array Indexzhler zurcksetzen
	do
	 {
      if(mode==8) //Bytes lesen
	   {
        if(program_mode>=SPI1)
         {
          be=SPIReadAVRByte(counter); //s.o.
         }

	    data[datcounter]=(unsigned char)be; 	//Array fllen
	    datcounter++;			//nchstes Arrayelement
	   }//if mode==8

      if(mode==16) //Worte lesen
	   {
        if(program_mode>=SPI1)
         {
          be=SPIReadAVRWord(counter); //s.o.
         }

	    data[datcounter]=(unsigned char)(be&0xFF); 	//LowByte
	    datcounter++;			//nchstes Arrayelement
	    data[datcounter]=(unsigned char)((be>>8)&0xFF); //HighByte
	    datcounter++;			//nchstes Arrayelement
	   }//if mode==16

	  counter++; 			// nchste Adresse

      UpdateProgress();

	 }while((datcounter<BLOCKSIZE)&&(counter<top)&&(mCancel==FALSE));

    if(mCancel==FALSE)
	 {
	  saved=fwrite(data,sizeof(unsigned char),datcounter,out);//Array schreiben
	  if(saved!=datcounter)
	   { Msg("Datenblock konnte nicht geschrieben werden !");
		 ShowErr(fname);     // Genaue Fehlermeldung
	   }
	 }

  }while((saved==datcounter)&&(counter<top)&&(mCancel==FALSE));

 if(out!=NULL){ fclose(out);  out=NULL; }

 if(mCancel==TRUE) return NO_OUTPUT;
 if(saved!=datcounter) return NO_OUTPUT;

 return NO_ERRORS;
}

