//************************************************************************
// Auslesen und sichern in einer IntelHEX Datei
// AVRPROM V1.xx fr Epromer V8.xx
//
// Holger Klabunde
// 13.01.1999
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Speichert ein Datenarray mit 8 Bit Daten in einer IntelHEX Datei
// Die vorher geffnet wurde FILE *out ist der Zeiger auf die Datei
unsigned long CAVRPromDlg::WriteIntelHex(unsigned char *dat,unsigned long start,unsigned long len)
{
 int result;		  //Fr fwrite()
 unsigned long adr; //Realer Adresszhler
 unsigned long datadr; //Adresszhler des Arrays
 unsigned long rest;//Noch zu schreibende Bytes
 unsigned long i;   //Allgemeiner Schleifenindex
 unsigned long count; //Lnge der Zeile beim Schreiben
 unsigned long checksum; //Checksumme der HEX-Zeile
 unsigned long hexbytes; //insgesamt geschriebene Datenbytes
 unsigned char check;    //Hilfsvariable
 unsigned long ffcount;  //Zeilen nur mit 0xFF nicht speichern
 unsigned char by;		 //Hilfsvariable
 char buff[ARRAYSIZE]; //Zeichenpuffer

 hexbytes=0;
 adr=(start&0xFFFF); //bei Intel8 Highadress ignorieren
							//und einfach Lowadress weiterzhlen
 rest=len; //Anzahl der zu schreibenden Datenbytes
 datadr=0; //Beginn bei dat[] Element 0

 do
  {
	checksum=0;
	strcpy(buff,":"); //Kennung Anfang der Zeile
	if(rest>=hexlen)
	 {
	  sprintf(zeile,"%02lX",hexlen);
	  strcat(buff,zeile); 		//Anzahl Datenbytes
	  checksum+=hexlen;     //gehrt zur Checksumme
	  count=hexlen;        //Anzahl zu schreibender Bytes
	 }
	else
	 {
	  sprintf(zeile,"%02lX",rest);   //weniger als hexlen
	  strcat(buff,zeile);
	  checksum+=rest;                //siehe oben
	  count=rest;
	 }

	sprintf(zeile,"%04lX",adr);    //Adresse eintragen
	strcat(buff,zeile);
	check=(unsigned char)(adr&0xFF); //Low und Highbyte zur Checksumme addieren
	checksum+=check;
	check=(unsigned char)((adr>>8)&0xFF);
	checksum+=check;

//Gehrt auch zur Checksumme, ist aber 0
	strcat(buff,"00"); // Kennzeichen Datenzeile

//Datenbytes einfgen
	ffcount=0; //Keine Zeilen mit Leerzellen schreiben
					 //Das beit sich aber mit Intel8 Hex-Dateien > 64kB !!
					 //Wenn ein ganzer 64kB	Block fehlt, werden die Daten
					 //mit falschem Offset gelesen
	for(i=0; i<count; i++)
	 {
	  by=dat[datadr+i]; //Datenbyte im Array
	  checksum+=by; // Alle Datenbytes in der Checksumme enthalten
	  sprintf(zeile,"%02X",by);
	  strcat(buff,zeile);
	  if(by==0xFF) ffcount++;
	  hexbytes++;       //Datenzhler fr Kontrolle
	 }

	checksum=~checksum; //Einerkomplement der Checksumme
	checksum+=1; // Zweierkomplement
	check=(unsigned char)(checksum&0x00FF); //Nur das Lowbyte
	sprintf(zeile,"%02X\n",check); //Wandeln in ASCII
	strcat(buff,zeile);            //An die Zeile anhngen

	if(ffcount<hexlen) //Zeilen nur mit "FF"-Daten nicht schreiben
	 {
	  result=fwrite(buff,strlen(buff),1,out); //Die ganze Zeile schreiben
	  if(result==0) //darf nicht 0 sein weil Daten da waren
		{ NoHexLine(); return hexbytes; }
	 }
	else
	 {
	  if(no_ff>0) //Auch Zeilen nur mit "FF"-Daten schreiben
		{ result=fwrite(buff,strlen(buff),1,out); //Die ganze Zeile schreiben
		  if(result==0) //darf nicht 0 sein weil Daten da waren
			{ NoHexLine(); return hexbytes; }
		}
	 }

	adr+=hexlen;    //Neuer Offset im EPROM
	datadr+=hexlen; //Neuer Offset im Array
	if(rest>=hexlen) rest-=hexlen;
	else rest=0; //Geschriebene Bytes abziehen

  }while(rest>0);

 return hexbytes;
}